/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-26 16:27:34 UTC)
 * on 2013-07-31 at 17:31:15 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.youtube.model;

/**
 * A list of video ratings returned as the response to a youtube.videos.getRating call.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the YouTube Data API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class VideoGetRatingResponse extends com.google.api.client.json.GenericJson {

  /**
   * The ETag of the response.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String etag;

  /**
   * A list of ratings that match the request criteria.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<VideoRating> items;

  /**
   * The type of the API response. For this operation, the value will be
   * youtube#videoGetRatingResponse.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * The ETag of the response.
   * @return value or {@code null} for none
   */
  public java.lang.String getEtag() {
    return etag;
  }

  /**
   * The ETag of the response.
   * @param etag etag or {@code null} for none
   */
  public VideoGetRatingResponse setEtag(java.lang.String etag) {
    this.etag = etag;
    return this;
  }

  /**
   * A list of ratings that match the request criteria.
   * @return value or {@code null} for none
   */
  public java.util.List<VideoRating> getItems() {
    return items;
  }

  /**
   * A list of ratings that match the request criteria.
   * @param items items or {@code null} for none
   */
  public VideoGetRatingResponse setItems(java.util.List<VideoRating> items) {
    this.items = items;
    return this;
  }

  /**
   * The type of the API response. For this operation, the value will be
   * youtube#videoGetRatingResponse.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * The type of the API response. For this operation, the value will be
   * youtube#videoGetRatingResponse.
   * @param kind kind or {@code null} for none
   */
  public VideoGetRatingResponse setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  @Override
  public VideoGetRatingResponse set(String fieldName, Object value) {
    return (VideoGetRatingResponse) super.set(fieldName, value);
  }

  @Override
  public VideoGetRatingResponse clone() {
    return (VideoGetRatingResponse) super.clone();
  }

}
